#include "scores.h"
#include "options.h"
#include "player.h"

#include <stdio.h>

ctr_t* scores=0;

void create_scores()
{
    su_t n;
    if(scores)
        destroy_scores();
    if((scores=malloc(sizeof(ctr_t)*MAX_LEVEL)))
        for(n=0;n<MAX_LEVEL;n++)
            scores[n]=(n<6?1000:2000);
}

void destroy_scores()
{
    if(scores)
        free(scores);
}

void load_scores()
{
    FILE* fp=0;
    char* fname=0;
    if(!scores)
        return;
    if(!options->user_dir)
        return;
    if((!(fname=options_file_path(".xorcurses",options->user_dir))))
        return;
    if(!(fp=fopen(fname,"r"))){
        free(fname);
        write_scores();
        return;
    }
    fread(scores,sizeof(ctr_t),MAX_LEVEL,fp);
    fclose(fp);
    free(fname);
}

void save_score(lvl_t level,ctr_t moves)
{
    if(!scores)
        return;
    if(level<MIN_LEVEL||level>=MAX_LEVEL)
        return;
    if(moves>MAX_MOVES)
        return;
    if(scores[level]>moves){
        scores[level]=moves;
        write_scores();
    }
}

void write_scores()
{
    FILE* fp=0;
    char* fname=0;
    if(!scores)
        return;
    if(!options->user_dir)
        return;
    if((!(fname=options_file_path(".xorcurses",options->user_dir))))
        return;
    if(!(fp=fopen(fname,"w")))
        return;
    fwrite(scores,sizeof(ctr_t),MAX_LEVEL,fp);
    fclose(fp);
    free(fname);
    return;
}
